package com.iqball.app.page

import android.util.Log
import androidx.compose.material3.Text
import androidx.compose.runtime.Composable
import androidx.compose.runtime.getValue
import androidx.compose.runtime.mutableStateOf
import androidx.compose.runtime.remember
import androidx.compose.runtime.setValue
import arrow.core.Either
import com.iqball.app.net.service.AuthService
import com.iqball.app.net.service.IQBallService
import kotlinx.coroutines.runBlocking

@Composable
fun RegisterPage(service: IQBallService) {
    var text by remember { mutableStateOf("No message !") }

    runBlocking {
        val result = service.login(AuthService.LoginRequest("maxime@mail.com", "123456"))

        when (result) {
            is Either.Left -> {
                println("Error : " + result.value)
                text = result.toString()
            }
            is Either.Right -> {
                val token = result.value.token
                val userDataResponse = service.getUserData(token)

                when (userDataResponse) {
                    is Either.Left -> println("Error User Data : " + userDataResponse.value)
                    is Either.Right -> println("Success User Data : " + userDataResponse.value)
                }

                text = userDataResponse.toString()
            }
        }

        println(result)
    }

    Text(text = text)
}
